'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var queueFactory = workerRespawnDelay => {
  const queue = [];
  let timeout;

  const startIfNotAlreadyStarted = () => {
    if (!timeout && queue.length) {
      timeout = setTimeout(processQueue, workerRespawnDelay);
    }
  };

  const processQueue = () => {
    timeout = null;
    if (queue.length) {
      const job = queue.shift();
      if (typeof job === 'function') {
        job();
      }
    }
    startIfNotAlreadyStarted();
  };

  return {
    push: job => {
      queue.push(job);
      startIfNotAlreadyStarted();
    },
  }
};

exports.default = queueFactory;

if(exports.default&&["object","function"].includes(typeof exports.default)){Object.assign(exports.default,exports);exports.default.default=module.exports=exports.default}
