'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var closeServerOrKillProcess = ({ log, workerKillTimeout }, server) => {
  if (server && typeof server.close === 'function') {
    server.close(() => process.exit(1));
  } else {
    log.warn(
      `No server with .close() method received (yet?) from workerFunction. Exiting anyway in ${workerKillTimeout} ms...`
    );
    setTimeout(() => process.exit(1), workerKillTimeout);
  }
};

exports.default = closeServerOrKillProcess;

if(exports.default&&["object","function"].includes(typeof exports.default)){Object.assign(exports.default,exports);exports.default.default=module.exports=exports.default}
