'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var cluster = _interopDefault(require('cluster'));
var closeServerOrKillProcess = require('./close-server-or-kill-process.js');

var uncaughtExceptionHandler = (options, serverOrPromise) => {
  const { log } = options;
  let isAlreadyCrashing = false;
  let server;

  if (serverOrPromise && typeof serverOrPromise.then === 'function') {
    serverOrPromise.then(actualServer => {
      if (isAlreadyCrashing) {
        closeServerOrKillProcess.default(options, actualServer);
      } else {
        server = actualServer;
      }
    });
  } else {
    server = serverOrPromise;
  }

  return err => {
    process.send('crashing');
    cluster.worker.disconnect();
    log.fatal('uncaughtException', err);
    isAlreadyCrashing = true;
    closeServerOrKillProcess.default(options, server);
  }
};

exports.default = uncaughtExceptionHandler;

if(exports.default&&["object","function"].includes(typeof exports.default)){Object.assign(exports.default,exports);exports.default.default=module.exports=exports.default}
